unit uSetupOctaGateURLBase;

interface

uses
  IWServerControllerBase, HTTPApp;

  procedure SetupOctaGateURLBase(IWServerController : TIWServerControllerBase;
    Request: TWebRequest);

  function GetPathRewrite(Request: TWebRequest) : string;

var
  OldOGPathRewrite  : string='';

implementation

procedure SetupOctaGateURLBase(IWServerController : TIWServerControllerBase;
  Request: TWebRequest);
var
  OGPathRewrite, Base : string;
  p : integer;
begin
  // Find out if OG performed a path rewrite
  OGPathRewrite := Request.GetFieldByName('OGPathRewrite');

  // Only perform the work if a different rewrite has been requested
  if (OGPathRewrite <> OldOGPathRewrite) then
  begin
    OldOGPathRewrite := OGPathRewrite;

    p := Pos(' ', OGPathRewrite);

    if p>0 then
    begin
      Base := Copy(OGPathRewrite, 1, p-1);

      // If the last char is a '/' we must drop it
      if Copy(Base, length(Base),1) = '/' then
        Base := Copy(Base, 1, Length(Base)-1);
    end else
      Base := '';

    if Base <> IWServerController.URLBase then
    begin
      IWServerController.URLBase := Base;
//      IWServerController.SessionTimeoutURL.URL := Base;
      IWServerController.SessionTimeoutURL.URL := Base+IWServerController.StartCmd;
      IWServerController.InvalidCommandURL := Base+IWServerController.StartCmd;
      IWServerController.UnknownBrowser.URL := Base+'/Files/HTML/NotSupported.html';
    end;
  end;
end;

function GetPathRewrite(Request: TWebRequest) : string;
var
  OGPathRewrite, Base : string;
  p : integer;
begin
  // Find out if OG performed a path rewrite
  OGPathRewrite := Request.GetFieldByName('OGPathRewrite');

  if OGPathRewrite<>'' then
  begin
    p := Pos(' ', OGPathRewrite);

    if p>0 then
    begin
      Base := Copy(OGPathRewrite, 1, p-1);

      // If the last char is a '/' we must drop it
      if Copy(Base, length(Base),1) = '/' then
        Base := Copy(Base, 1, Length(Base)-1);
    end else
      Base := '';

    result := Base;
  end else
    result := '';
end;
end.


